
/********************************************************************************/
/*                        	* Frecuency-Counter code *                          */
/*                            By George A. Adamidis                             */
/*                            Ver 1.0 - March 17, 2009                          */ 
/********************************************************************************/
// All rights are reserved 


// Compiled using MPLAB-C18 V 8.10
// Loaded on a PIC18F2620 microcontroler
// All timing routines have been written for 4MHz master clock.
//--------------------------------------------------------------------------------

#include "Common.h"         /* General Definitions          */
#include <p18cxxx.h>        /* TRISB and PORTB declarations */
#include <xlcd.h>           /* LCD purpose routines         */
#include <delays.h>         /* Delay purpose routines       */

/*functions declaration*/
char buttonpressed (void);     // Return 0,1,2,3 or 4 if no button, mode button, function button, units button or channel button is being pressed.  
void action(unsigned char but);  // Perfoms the appropriate function if button "but" has been pressed (but - 1,2,3 or 4)
void disst(void); 				// Displays current device state at LCD's second line, 
extern void displayfreq (unsigned long freq); 		

													    	
/*variables declaration*/
extern volatile float Overflow;
extern char mode;
extern char function;
extern float maxhold;		    
extern float minhold;     		
extern char units;
extern char channel;
extern unsigned long frequency;  

/******************************************************************************************************************/
// Return 0,1,2,3 or 4 if no button, mode button, function button,  units button, or channel button is being pressed.
char buttonpressed (void)
{
// Button MODE            ---> KEY1   
// Button FUNCTION        ---> KEY2   
// Button UNITS           ---> KEY3 
// Button CHANNEL		  ---> KEY4

char state=0;

if (KEY1) state=3;
if (KEY2) state=1;
if (KEY3) state=2;
if (KEY4) state=4;
return state;

}        


/******************************************************************************************************************/
// Perfoms the appropriate function if button "but" has been pressed (but - 1,2,3 or 4)
void action(unsigned char but)
{
Overflow=0;                  // resets overflow variable

if (but==1)					// Mode button has been pressed	
	{
       	mode++;
        if (mode>2) mode=0;
		displayfreq (frequency);   // Display frequency 
		disst(); 
	 	
	}

if (but==2)					// Function button has been pressed
	{
	 	function++;
	 	if (function>2) function=0;
     	maxhold=0;		   	
	 	minhold=19999999999;
	 	disst();  
	}   
       
if (but==3)					// Units button has been pressed
	{
	
		units++;
		if (units>2) units=0;
    	displayfreq (frequency);   // Display frequency 
	}
	
if (but==4)					// Channel button has been pressed
	{
		channel++;
		if (channel>2) channel=1;
		displayfreq (frequency);   // Display frequency 
	}
		

//	// Displays current device state on the LCD  
//	while (buttonpressed()>0)Delay10KTCYx(1);    //waits for any button to be de-pressed

	Delay10KTCYx(25);
} 